﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class ExampleController : MonoBehaviour, AdscendMedia.RewardedVideoCallback, AdscendMedia.OffersCallback, AdscendMedia.SurveysCallback, AdscendMedia.TransactionsCallback, AdscendMedia.CompletedOffersCallback
{

	public GUIStyle style;

	string publisherId = "32740";
	string adwallId = "2074";
	string subId1 = "unity_demo_subid1";
	string profileId = "365";
	string mr_profileId = "3";
	//market research profile id

	// Update is called once per frame
	void Update ()
	{
		if (Input.GetKeyDown (KeyCode.Escape))
			Application.Quit (); 
	}

	void Start ()
	{
		/*
		SAMPLE CODE ONLY
		*/

		//Offset = 0
		AdscendMedia.getOffers (name, publisherId, adwallId, subId1, 0);

		//ProductId = "4". 
		// "4" is for surveys on offer wall profile
		// "10" is for surveys on mr profile
		AdscendMedia.getSurveys (name, publisherId, profileId, subId1, "4");
		
		AdscendMedia.getTransactions (name, publisherId, adwallId, subId1);
		
		AdscendMedia.getCompletedOffers (name, publisherId, adwallId, subId1);
		
		/*
		SAMPLE CODE ONLY
		*/
	}

	public void onVideoClick ()
	{
		Debug.Log ("onVideoClick " + name);

		//you cannot pass anything but the internal property 'name' as first parameter otherwise call backs won't work
		AdscendMedia.PlayRewardedVideo (name, publisherId, profileId, subId1);
	}

	public void onOfferWallClick ()
	{
		Debug.Log ("onOfferWallClick " + name);

		Dictionary<string, string> dictionary = new Dictionary<string, string> ();
		dictionary.Add (AdscendMedia.SUB_ID2, "demo_subid2");
		dictionary.Add (AdscendMedia.SUB_ID3, "demo_subid3");
		dictionary.Add (AdscendMedia.SUB_ID4, "demo_subid4");
		dictionary.Add (AdscendMedia.GENDER, AdscendMedia.GENDER_FEMALE);
		dictionary.Add (AdscendMedia.AGE_RANGE, AdscendMedia.AGE_18_TO_35);

		//you cannot pass anything but the internal property 'name' as first parameter otherwise call backs won't work
		AdscendMedia.ShowOfferWall (name, publisherId, adwallId, subId1, dictionary);
	}

	//callback for watching a rewarded video, see AdscendMedia.RewardedVideoCallback
	public void userWasCredited ()
	{
		Debug.Log ("User Credited For Watching a Rewarded Video");
	}

	public void userWasNotCredited ()
	{
		Debug.Log ("User Not Credited For Watching a Rewarded Video");
	}

	public void onSuccess(string message)
	{
		Debug.Log ("Rewarded Video data avilable rsponse success ->" + message);
	}
	
	public void onFailure(string failureMsg)
	{
		Debug.Log ("Rewarded Video failure ->"+failureMsg );
	}
	
	public void onError(int errorCode)
	{
		Debug.Log ("Media player error ->"+ errorCode);
	}
	
	public void onRerwarded()
	{
		Debug.Log ("User Credited For Watching a Rewarded Video ->");
	}
	
	public void onClosed()
	{
		Debug.Log ("Media player closed ->");
	}

	public void onMarketResearchClick ()
	{
		Debug.Log ("onMarketResearchClick " + name);

		Dictionary<string, string> dictionary = new Dictionary<string, string> ();
		dictionary.Add (AdscendMedia.SUB_ID2, "demo_subid2");
		dictionary.Add (AdscendMedia.SUB_ID3, "demo_subid3");
		dictionary.Add (AdscendMedia.SUB_ID4, "demo_subid4");

		//you cannot pass anything but the internal property 'name' as first parameter otherwise call backs won't work
		AdscendMedia.ShowMarketResearch (name, publisherId, mr_profileId, subId1, dictionary);
	}

	#region Sample
	/*
		SAMPLE CODE ONLY
	*/
	public void getOffersResponseSuccess (string result)
	{
		Debug.Log ("getOffersResponseSuccess -> " + result + "<-");
	}

	public void getOffersResponseFailure (string failureMsg)
	{
		Debug.Log ("getOffersResponseFailure ->  <- ");
	}

	public void getSurveysResponseSuccess (string result)
	{
		Debug.Log ("getSurveysResponseSuccess -> " + result + "<-");
	}

	public void getSurveysResponseNotFound ()
	{
		Debug.Log ("getSurveysResponseNotFound ->  <- ");
	}

	public void getSurveysResponseFailure (string failureMsg)
	{
		Debug.Log ("getSurveysResponseFailure ->  <- ");
	}

	public void getTransactionsResponseSuccess (string result)
	{
		Debug.Log ("getTransactionsResponseSuccess -> " + result + "<-");
	}

	public void getTransactionsResponseFailure (string failureMsg)
	{
		Debug.Log ("getTransactionsResponseFailure ->  <- ");
	}

	public void getCompletedOffersResponseSuccess (string result)
	{
		Debug.Log ("getCompletedOffersResponseSuccess -> " + result + "<-");
	}

	public void getCompletedOffersResponseFailure (string failureMsg)
	{
		Debug.Log ("getCompletedOffersResponseFailure ->  <- ");
	}
	/*
		SAMPLE CODE ONLY
	*/

	#endregion Sample


}