﻿using UnityEngine;
using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;

/*
 * 	DO NOT MODIFY THIS FILE
 */

public class AdscendMedia : MonoBehaviour
{

	#region AdscendMedia SDK

	public static string SUB_ID2 = "subid2";
	public static string SUB_ID3 = "subid3";
	public static string SUB_ID4 = "subid4";
	public static string GENDER = "gender";
	public static string AGE_RANGE = "age_range_id";
	
	public static string GENDER_MALE = "m";
	public static string GENDER_FEMALE = "f";
	
	public static string AGE_18_TO_35 = "1";
	public static string AGE_35_TO_45 = "2";
	public static string AGE_45_TO_55 = "3";
	public static string AGE_55_TO_65 = "4";
	public static string AGE_65 = "5";

	public interface RewardedVideoCallback
	{
		void userWasCredited ();

		void userWasNotCredited ();

		void onSuccess(string message);

		void onFailure(string failureMsg);

		void onError(int errorCode);

		void onRerwarded();

		void onClosed();
	}

	public interface OffersCallback
	{
		void getOffersResponseSuccess (string result);

		void getOffersResponseFailure (string failureMsg);
	}

	public interface SurveysCallback
	{
		void getSurveysResponseSuccess (string result);

		void getSurveysResponseNotFound ();

		void getSurveysResponseFailure (string failureMsg);
	}

	public interface TransactionsCallback
	{
		void getTransactionsResponseSuccess (string result);

		void getTransactionsResponseFailure (string failureMsg);
	}

	public interface CompletedOffersCallback
	{
		void getCompletedOffersResponseSuccess (string result);

		void getCompletedOffersResponseFailure (string failureMsg);
	}

	public static void ShowOfferWall (string objectName, string publisherId, string adwallId, string subId1, Dictionary<string, string> options = null)
	{
		#if UNITY_IPHONE
		if (options != null) {
			string optionsString = "";
			foreach (KeyValuePair<string, string> kvp in options) {
				optionsString += kvp.Key + "=" + kvp.Value + "\n";
			}
			AdscendMedia._showOfferWallWithOptions (objectName, publisherId, adwallId, subId1, optionsString);
		} else {
			AdscendMedia._showOfferWall (objectName, publisherId, adwallId, subId1);
		}

		#elif UNITY_ANDROID			
		AndroidJavaClass bridgeClass = new AndroidJavaClass("com.adscendmedia.unity.SDKBridge");

		if (options != null)
		{
			AndroidJavaObject j_options = CreateJavaHashtable(options);
			bridgeClass.CallStatic("showOfferWall", objectName, publisherId, adwallId, subId1, j_options);
		}
		else
		{
			bridgeClass.CallStatic("showOfferWall", objectName, publisherId, adwallId, subId1);
		}
		#endif		
	}

	public static void ShowMarketResearch (string objectName, string publisherId, string profileId, string subId1, Dictionary<string, string> options = null)
	{
		#if UNITY_IPHONE
		if (options != null) {
			string optionsString = "";
			foreach (KeyValuePair<string, string> kvp in options) {
				optionsString += kvp.Key + "=" + kvp.Value + "\n";
			}
			AdscendMedia._showMarketResearchWithOptions (objectName, publisherId, profileId, subId1, optionsString);
		} else {
			AdscendMedia._showMarketResearch (objectName, publisherId, profileId, subId1);
		}

		#elif UNITY_ANDROID			
		AndroidJavaClass bridgeClass = new AndroidJavaClass("com.adscendmedia.unity.SDKBridge");

		if (options != null)
		{
			AndroidJavaObject j_options = CreateJavaHashtable(options);
			bridgeClass.CallStatic("showMarketResearch", objectName, publisherId, profileId, subId1, j_options);
		}
		else
		{
			bridgeClass.CallStatic("showMarketResearch", objectName, publisherId, profileId, subId1);
		}
		#endif		
	}

	public static void PlayRewardedVideo (string objectName, string publisherId, string profileId, string subId1)
	{
		#if UNITY_IPHONE
		AdscendMedia._playRewardedVideo (objectName, publisherId, profileId, subId1);
		#elif UNITY_ANDROID	

		AndroidJavaClass bridgeClass = new AndroidJavaClass("com.adscendmedia.unity.SDKBridge");
		bridgeClass.CallStatic("playRewardedVideo", objectName, publisherId, profileId, subId1);

		#endif
	}

	public static void getOffers (string objectName, string publisherId, string adWallId, string subId1, int offset)
	{
		#if UNITY_IPHONE
		AdscendMedia._getOfferList (objectName, publisherId, adWallId, subId1, offset);
		#elif UNITY_ANDROID
		AndroidJavaClass bridgeClass = new AndroidJavaClass("com.adscendmedia.unity.SDKBridge");
		bridgeClass.CallStatic("getOffersList", objectName, publisherId, adWallId, subId1, offset);
		#endif
	}

	public static void getSurveys (string objectName, string publisherId, string profileId, string subId1, string productId)
	{
		#if UNITY_IPHONE
		AdscendMedia._getSurveys (objectName, publisherId, profileId, subId1, productId);
		#elif UNITY_ANDROID
		AndroidJavaClass bridgeClass = new AndroidJavaClass("com.adscendmedia.unity.SDKBridge");
		bridgeClass.CallStatic("getSurveysList", objectName, publisherId, profileId, subId1, productId);
		#endif
	}

	public static void getTransactions (string objectName, string publisherId, string adWallId, string subId1)
	{
		#if UNITY_IPHONE
		AdscendMedia._getTransactions (objectName, publisherId, adWallId, subId1);
		#elif UNITY_ANDROID
		AndroidJavaClass bridgeClass = new AndroidJavaClass("com.adscendmedia.unity.SDKBridge");
		bridgeClass.CallStatic("getTransactionHistoryList", objectName, publisherId, adWallId, subId1);
		#endif
	}

	public static void getCompletedOffers (string objectName, string publisherId, string adWallId, string subId1)
	{
		#if UNITY_IPHONE
		AdscendMedia._getCompletedOffers(objectName, publisherId, adWallId, subId1);
		#elif UNITY_ANDROID
		AndroidJavaClass bridgeClass = new AndroidJavaClass("com.adscendmedia.unity.SDKBridge");
		bridgeClass.CallStatic("getCompletedTransactions", objectName, publisherId, adWallId, subId1);
		#endif
	}

	#endregion

	#region Helpers

	#if UNITY_ANDROID
	private static AndroidJavaObject CreateJavaHashtable(Dictionary<string, string> kvPairs)
	{
		var j_Hashtable = new AndroidJavaObject("java.util.Hashtable");
		IntPtr method_Put = AndroidJNIHelper.GetMethodID(j_Hashtable.GetRawClass(), "put", "(Ljava/lang/Object;Ljava/lang/Object;)Ljava/lang/Object;");
		
		if (kvPairs != null)
		{
			object[] args = new object[2];
			foreach (KeyValuePair<string, string> kvp in kvPairs)
			{
				using (AndroidJavaObject k = new AndroidJavaObject("java.lang.String", kvp.Key))
				{
					using (AndroidJavaObject v = new AndroidJavaObject("java.lang.String", kvp.Value))
					{
						args[0] = k;
						args[1] = v;
						AndroidJNI.CallObjectMethod(j_Hashtable.GetRawObject(),
						                            method_Put, AndroidJNIHelper.CreateJNIArgArray(args));
					}
				}
			}
		}
		return j_Hashtable;
	}
	#endif

	#endregion

	#region Externals

	#if UNITY_IOS

	[DllImport ("__Internal")]
	private static extern void _showMarketResearch (string objectName, string publisherId, string profileId, string subId1);

	[DllImport ("__Internal")]
	private static extern void _showMarketResearchWithOptions (string objectName, string publisherId, string profileId, string subId1, string options);

	[DllImport ("__Internal")]
	private static extern void _showOfferWall (string objectName, string publisherId, string adwallId, string subId1);

	[DllImport ("__Internal")]
	private static extern void _showOfferWallWithOptions (string objectName, string publisherId, string adwallId, string subId1, string options);

	[DllImport ("__Internal")]
	private static extern void _playRewardedVideo (string objectName, string publisherId, string profileId, string subId1);

	[DllImport ("__Internal")]
	private static extern void _getOfferList (string objectName, string publisherId, string adWallId, string subId1, int offset);

	[DllImport ("__Internal")]
	private static extern void _getSurveys (string objectName, string publisherId, string profileId, string subId1, string productId);

	[DllImport ("__Internal")]
	private static extern void _getTransactions (string objectName, string publisherId, string adWallId, string subId1);

	[DllImport ("__Internal")]
	private static extern void _getCompletedOffers (string objectName, string publisherId, string adWallId, string subId1);

	#endif
	#endregion
}
